Doomsday Engine - Feature #1548

Multi-monitor support
2011-10-09 17:58 - znerolnoht

Status: Progressed Start date: 2011-10-09
Priority: Normal % Done: 40%
Assignee:

Category: Redesign

Target version: Rendering Il

Description

Is Multi-Monitor support, playback of doomsday games spanning multiple monitors, possible? | have 3 monitors and it would be
amazing if we could get a peripheral view on the second and third monitors. | think it would be a great feature. Please let me know if
this is something you guys would add.

Thanks,
~Long time fan

Labels: Graphics

History

#1 - 2012-08-27 21:08 - danij

Indeed it would be a great feature and is one | have been working on in the ringzero branch in fact. | hope to have multi-monitor support complete
when it is time to merge this work back to the master.

#2 - 2012-08-27 21:08 - danij

- assigned_to: Daniel Swanson --> nobody

#3 - 2012-08-28 16:51 - danij

Removing myself as owner of this item as | no longer use have a multi-monitor setup to test support with.

#4 - 2013-10-22 12:09 - skyjake

- Tags set to WindowManager, GL2

- Subject changed from Multi-Monitor Support to Multi-monitor support
- Category set to Redesign

- Status changed from New to In Progress

- % Done changed from 0 to 30

Proper multi-monitor support implies support for multiple/split game windows. In recent times Doomsday's window manager has been OO-ifying,
making it realistic to start implementing well-behaved multi-window rendering, where the separate GL surfaces share a single GL context.

#5 - 2013-10-22 23:10 - danij

| question whether sharing of a GL-context is possible. Surely, this mandates that both monitors are exactly the same and configured in exactly the
same way.

#6 - 2013-10-23 07:52 - skyjake
danij wrote:
Surely, this mandates that both monitors are exactly the same and configured in exactly the same way.
I think what sharing in this situation actually means that there are two or more GL surfaces+contexts that use the same buffers, FBOs, and texture
objects (and shaders, | suppose?).

The sharing mechanism is already in use in CanvasWindow when one recreates the GL surface due to runtime FSAA change: the new Canvas
shares the old one's objects (but not state).

#7 - 2015-03-07 16:59 - skyjake
Assuming that the monitors are set up as an extended desktop, it would be possible to configure a Nx1 viewgrid with a separate 3D viewpoint for
each monitor. The advantage compared to a multi-window approach would be simplicity since there would only be a single OpenGL surface in use.

#8 - 2016-07-05 23:56 - skyjake

- Status changed from In Progress to Progressed

#9 - 2019-11-29 16:33 - skyjake
- Target version set to Rendering I

- % Done changed from 30 to 40

Incrementing progress as 3.0 supports rendering to multiple windows with a shared GL context.
